;WFX API window

includepath "..\"
includefile "wfxframework.pbi"

enableexplicit

structure MY_APP
	test.i
	but1.i
	but2.i
endstructure 

procedure commands(hwnd.i, code.i, p1.i, p2.i, *app.MY_APP)
	select code
		case #WFX_NM_CMDCLICK
			debug "command " + str(p1)

		case #WFX_NM_CMDACCEL
			debug "accelerator " + str(p1)
	endselect 
endprocedure

procedure OnWindowCreate(hwnd.i, msg.i, wparam.i, lparam.i, *app.MY_APP)
	define.RECT rc
	define.WFX_ACCELOBJECT *accel

	wfx__SetCallback(hwnd, @commands()) ;set window events

	;Make accelerator table
	*accel = wfx__AcceleratorObject()
	wfx__AppendAccelerator(*accel, #FCONTROL|#FVIRTKEY, #PB_Shortcut_A, 1)
	wfx__SetAcceleratorObject(hwnd, *accel, #true) ;set accelerators and free object

	;Child controls
	GetClientRect_(hwnd, @rc) 
	*app\but1 = wfx__Button(0, "Button 1", #WS_CHILD|#WS_VISIBLE|#WS_TABSTOP, 0, rc\bottom - 20, 80, 20, hwnd, 1, @commands())
	wfx_SetAnchor(*app\but1, #WFX_ANCHORBOTTOM)

	*app\but2 = wfx__Button(0, "Button 2", #WS_CHILD|#WS_VISIBLE|#WS_TABSTOP, 100, rc\bottom - 20, 80, 20, hwnd, 2, @commands())
	wfx_SetAnchor(*app\but2, #WFX_ANCHORBOTTOM)

	procedurereturn 0
endprocedure 

procedure wndproc(hwnd.i, msg.i, wparam.i, lparam.i, *app.MY_APP)
	select msg
		case #WM_CREATE : procedurereturn OnWindowCreate(hwnd, msg, wparam, lparam, *app)

		case #WM_CLOSE
			;Confirm?
			DestroyWindow_(hwnd)
			procedurereturn 0

		case #WM_DESTROY
			PostQuitMessage_(0)
			procedurereturn 0

		default : procedurereturn DefWindowProc_(hwnd, msg, wparam, lparam)
	endselect 
endprocedure 

procedure RunApplication()
	define.MY_APP app ;this could store all your application data
	
	app\test = 10

	wfx__OpenWindow(#WS_EX_CONTROLPARENT, "WFX API Window", #WS_OVERLAPPEDWINDOW|#WS_VISIBLE, 10, 10, 300, 200, 0, @wndproc(), @app)
endprocedure 

;- CODE
RunApplication()

