;wfxAccelerators.pbi

;Functions to create accelerator tables from memory

xincludefile "wfx.pbi"

structure VECTOR_ACCEL
	el.ACCEL[0]
endstructure

structure WFX_ACCELOBJECT
	*table.VECTOR_ACCEL
	elements.i
endstructure 

procedure wfx__AcceleratorObject()
;Creates an accelerator object

	define.WFX_ACCELOBJECT *acc

	*acc = allocatememory(sizeof(WFX_ACCELOBJECT))

	procedurereturn *acc
endprocedure 

procedure wfx__FreeAcceleratorObject(*acc.WFX_ACCELOBJECT)
;Frees the accelerator object

	if *acc
		if *acc\table
			freememory(*acc\table)
		endif
		freememory(*acc)
	endif
endprocedure 

procedure wfx__AppendAccelerator(*acc.WFX_ACCELOBJECT, fVirt.b, key.w, cmd.w)
;Appends an accelerator to the accelerator object

	if *acc
		*acc\elements = *acc\elements + 1
		*acc\table = reallocatememory(*acc\table, sizeof(ACCEL) * *acc\elements)
		with *acc\table\el[*acc\elements - 1]
			\fVirt = fVirt
			\key = key
			\cmd = cmd
		endwith 
	endif 
endprocedure 

macro wfx__CreateAcceleratorTable(acc)
;Creates an win accelerator handle from an accelerator object
	CreateAcceleratorTable_(acc\table, acc\elements)
endmacro

procedure wfx__SetAcceleratorObject(hwnd.i, *acc.WFX_ACCELOBJECT, free.b=#false)
;Creates an accelerator table from an accelerator object and assigns it to the
;top level window. The accelerator object is not stored in the window object, only the
;accelerator api handle. Optionally the object memory can be freed.

	define.WFX_TOPLEVEL *this = wfx__GetWindowObject(hwnd)

	if *this and *acc
		*this\hAccelTable = wfx__CreateAcceleratorTable(*acc)
		if free : wfx__FreeAcceleratorObject(*acc) : endif 
	endif
endprocedure




